#25 RPCService client exception with transport closed

None
open
1
2015-01-05
2014-04-22
guobao shen
No

RPC client ends with an exception, and closes transport when there are many RPC calls issued , for example more than 2 per seconds. Found this during testing MASAR service.

Discussion

  • guobao shen
    guobao shen
    2014-04-22

     
  • guobao shen
    guobao shen
    2014-04-22

    RPC client ends with an exception, and closes transport when there are many RPC calls issued , for example more than 2 per seconds. Found this during testing MASAR service.

     
  • Note that 3.0.4 release code is used (non-codec).
    The exception says: a connection was closed while deserializing RPC response.

    Is server shutting down? Where can I find the latest code?

     
  • guobao shen
    guobao shen
    2014-04-22

    Note that 3.0.4 release code is used (non-codec).
    Yes. This is a following up with the topic Marty and I had weeks ago.
    Precisely, this is tagged release/3.0.4, which Marty created recently.

    The exception says: a connection was closed while deserializing RPC response.

    Is server shutting down?
    No. The server is running. If I wait a few seconds, and issue another RPC call, it works just fine.

    Where can I find the latest code?
    The latest code could be found from our repos.
    The version for each module I am using is as below:
    pvDataCPP 3.0.2
    pvCommonCPP 3.0.2
    pvAccessCPP release/3.0.4
    normativeTypesCPP latest checkout
    masarService: feature/removePVIOCCPP

     
  • guobao shen
    guobao shen
    2014-04-22

    One more clue (need to confirm):
    the exception most likely happens when RPC server gets a command before it replies previous request.

     
  • guobao shen
    guobao shen
    2014-04-23

    After tracking down into the pvAccessCPP, the error is throwing out from the line 524
    in pvAccessApp/remote/blockingTCPTransport.cpp.

     
  • guobao shen
    guobao shen
    2014-04-23

    That was saw during my testing, which resulted errors in client like:
    2014-04-23T14:34:17.082 Invalid header received from client 10.0.152.82:5075, disconnecting...
    2014-04-23T14:34:17.082 Invalid header received from client 10.0.152.82:5075, disconnecting...